<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for dtoCheckSubscriptionResult StructType
 * @subpackage Structs
 */
class DtoCheckSubscriptionResult extends AbstractStructBase
{
    /**
     * The additionalInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $additionalInfo;
    /**
     * The checkCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $checkCode;
    /**
     * The hasContract
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hasContract;
    /**
     * The insuredSmsMessage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $insuredSmsMessage;
    /**
     * The isAllowed
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $isAllowed;
    /**
     * The maxCoveredCount
     * @var int
     */
    public $maxCoveredCount;
    /**
     * The message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The partnerSmsMessage
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $partnerSmsMessage;
    /**
     * The priceInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $priceInfo;
    /**
     * The serviceId
     * @var int
     */
    public $serviceId;
    /**
     * The unit
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $unit;
    /**
     * Constructor method for dtoCheckSubscriptionResult
     * @uses DtoCheckSubscriptionResult::setAdditionalInfo()
     * @uses DtoCheckSubscriptionResult::setCheckCode()
     * @uses DtoCheckSubscriptionResult::setHasContract()
     * @uses DtoCheckSubscriptionResult::setInsuredSmsMessage()
     * @uses DtoCheckSubscriptionResult::setIsAllowed()
     * @uses DtoCheckSubscriptionResult::setMaxCoveredCount()
     * @uses DtoCheckSubscriptionResult::setMessage()
     * @uses DtoCheckSubscriptionResult::setPartnerSmsMessage()
     * @uses DtoCheckSubscriptionResult::setPriceInfo()
     * @uses DtoCheckSubscriptionResult::setServiceId()
     * @uses DtoCheckSubscriptionResult::setUnit()
     * @param string $additionalInfo
     * @param string $checkCode
     * @param string $hasContract
     * @param string $insuredSmsMessage
     * @param string $isAllowed
     * @param int $maxCoveredCount
     * @param string $message
     * @param string $partnerSmsMessage
     * @param string $priceInfo
     * @param int $serviceId
     * @param string $unit
     */
    public function __construct($additionalInfo = null, $checkCode = null, $hasContract = null, $insuredSmsMessage = null, $isAllowed = null, $maxCoveredCount = null, $message = null, $partnerSmsMessage = null, $priceInfo = null, $serviceId = null, $unit = null)
    {
        $this
            ->setAdditionalInfo($additionalInfo)
            ->setCheckCode($checkCode)
            ->setHasContract($hasContract)
            ->setInsuredSmsMessage($insuredSmsMessage)
            ->setIsAllowed($isAllowed)
            ->setMaxCoveredCount($maxCoveredCount)
            ->setMessage($message)
            ->setPartnerSmsMessage($partnerSmsMessage)
            ->setPriceInfo($priceInfo)
            ->setServiceId($serviceId)
            ->setUnit($unit);
    }
    /**
     * Get additionalInfo value
     * @return string|null
     */
    public function getAdditionalInfo()
    {
        return $this->additionalInfo;
    }
    /**
     * Set additionalInfo value
     * @param string $additionalInfo
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setAdditionalInfo($additionalInfo = null)
    {
        // validation for constraint: string
        if (!is_null($additionalInfo) && !is_string($additionalInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($additionalInfo, true), gettype($additionalInfo)), __LINE__);
        }
        $this->additionalInfo = $additionalInfo;
        return $this;
    }
    /**
     * Get checkCode value
     * @return string|null
     */
    public function getCheckCode()
    {
        return $this->checkCode;
    }
    /**
     * Set checkCode value
     * @param string $checkCode
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setCheckCode($checkCode = null)
    {
        // validation for constraint: string
        if (!is_null($checkCode) && !is_string($checkCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkCode, true), gettype($checkCode)), __LINE__);
        }
        $this->checkCode = $checkCode;
        return $this;
    }
    /**
     * Get hasContract value
     * @return string|null
     */
    public function getHasContract()
    {
        return $this->hasContract;
    }
    /**
     * Set hasContract value
     * @param string $hasContract
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setHasContract($hasContract = null)
    {
        // validation for constraint: string
        if (!is_null($hasContract) && !is_string($hasContract)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hasContract, true), gettype($hasContract)), __LINE__);
        }
        $this->hasContract = $hasContract;
        return $this;
    }
    /**
     * Get insuredSmsMessage value
     * @return string|null
     */
    public function getInsuredSmsMessage()
    {
        return $this->insuredSmsMessage;
    }
    /**
     * Set insuredSmsMessage value
     * @param string $insuredSmsMessage
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setInsuredSmsMessage($insuredSmsMessage = null)
    {
        // validation for constraint: string
        if (!is_null($insuredSmsMessage) && !is_string($insuredSmsMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($insuredSmsMessage, true), gettype($insuredSmsMessage)), __LINE__);
        }
        $this->insuredSmsMessage = $insuredSmsMessage;
        return $this;
    }
    /**
     * Get isAllowed value
     * @return string|null
     */
    public function getIsAllowed()
    {
        return $this->isAllowed;
    }
    /**
     * Set isAllowed value
     * @param string $isAllowed
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setIsAllowed($isAllowed = null)
    {
        // validation for constraint: string
        if (!is_null($isAllowed) && !is_string($isAllowed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isAllowed, true), gettype($isAllowed)), __LINE__);
        }
        $this->isAllowed = $isAllowed;
        return $this;
    }
    /**
     * Get maxCoveredCount value
     * @return int|null
     */
    public function getMaxCoveredCount()
    {
        return $this->maxCoveredCount;
    }
    /**
     * Set maxCoveredCount value
     * @param int $maxCoveredCount
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setMaxCoveredCount($maxCoveredCount = null)
    {
        // validation for constraint: int
        if (!is_null($maxCoveredCount) && !(is_int($maxCoveredCount) || ctype_digit($maxCoveredCount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($maxCoveredCount, true), gettype($maxCoveredCount)), __LINE__);
        }
        $this->maxCoveredCount = $maxCoveredCount;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get partnerSmsMessage value
     * @return string|null
     */
    public function getPartnerSmsMessage()
    {
        return $this->partnerSmsMessage;
    }
    /**
     * Set partnerSmsMessage value
     * @param string $partnerSmsMessage
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setPartnerSmsMessage($partnerSmsMessage = null)
    {
        // validation for constraint: string
        if (!is_null($partnerSmsMessage) && !is_string($partnerSmsMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partnerSmsMessage, true), gettype($partnerSmsMessage)), __LINE__);
        }
        $this->partnerSmsMessage = $partnerSmsMessage;
        return $this;
    }
    /**
     * Get priceInfo value
     * @return string|null
     */
    public function getPriceInfo()
    {
        return $this->priceInfo;
    }
    /**
     * Set priceInfo value
     * @param string $priceInfo
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setPriceInfo($priceInfo = null)
    {
        // validation for constraint: string
        if (!is_null($priceInfo) && !is_string($priceInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priceInfo, true), gettype($priceInfo)), __LINE__);
        }
        $this->priceInfo = $priceInfo;
        return $this;
    }
    /**
     * Get serviceId value
     * @return int|null
     */
    public function getServiceId()
    {
        return $this->serviceId;
    }
    /**
     * Set serviceId value
     * @param int $serviceId
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setServiceId($serviceId = null)
    {
        // validation for constraint: int
        if (!is_null($serviceId) && !(is_int($serviceId) || ctype_digit($serviceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($serviceId, true), gettype($serviceId)), __LINE__);
        }
        $this->serviceId = $serviceId;
        return $this;
    }
    /**
     * Get unit value
     * @return string|null
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @param string $unit
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: string
        if (!is_null($unit) && !is_string($unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unit, true), gettype($unit)), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DtoCheckSubscriptionResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
